function fig = gui_fl_d2ml2frontier()

% MAIN WINDOW
a = figure('Color',[0.8 0.8 0.8], ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Position',[165 50 360 500], ...
	'Units','pixels', ...
	'UserData',struct('Function',0,'Precision_frontier',10,'Frontier',0,'Choice_estim',0,'Choice_example',0), ...
	'Tag','gui_fl_d2ml2frontier_control_panel');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TITLE FRAME    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.252631578947368, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.895 0.96 0.095], ...
	'Style','frame', ...
	'Tag','Frame_title');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.94 0.8 0.035], ...
	'String','Oscillation based 2-Micro-local Frontier', ...
	'Style','text', ...
	'Tag','StaticText_Title');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.90 0.8 0.035], ...
	'String','Estimation at 1 point (Method 2) for images', ...
	'Style','text', ...
	'Tag','StaticText_Title');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT FRAME
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.4, ...
	'Position',[0.02 0.825 0.96 0.06], ...
	'Style','frame', ...
	'Tag','Frame_input');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.835 0.25 0.035], ...
	'String','Input Image', ...
	'Style','text', ...
	'Tag','StaticText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*0.685714285714286, ...
	'HorizontalAlignment','center', ...
	'Position',[0.32 0.84 0.4 0.035], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive', ...
	'Tag','EditText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2frontier_compute(''refresh_input'');', ...
	'FontSize',0.88*0.533333333333333, ...
	'FontWeight','bold', ...
	'Position',[0.75 0.835 0.175 0.045], ...
	'String','Refresh', ...
	'Tag','Pushbutton_refreshInput');
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.123076923076923, ...
	'Position',[0.02 0.622 0.96 0.195], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.770 0.8 0.035], ...
	'String','2-microlocal frontier Estimation', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');


%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.649 0.60 0.04], ...
	'String','Discretization of the frontier', ...
	'Style','text', ...
	'Tag','StaticText_estim');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2frontier_compute(''precision_exp'');', ...
	'FontSize',0.88*0.48, ...
	'ListboxTop',0, ...
	'Max',5, ...
	'Min',1, ...
	'Position',[0.625   0.651    0.20    0.05], ...
	'String',{'10','15','20','25','30'}, ...
	'Style','popupmenu', ...
	'Tag','precision_exp', ...
	'Value',1);
%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.704 0.45 0.04], ...
	'String','Analyzed point', ...
	'Style','text', ...
	'Tag','StaticText_point');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.56 0.704 0.15 0.04], ...
	'String','X', ...
	'Style','text', ...
	'Tag','StaticText_point');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.61 0.714 0.11 0.04], ...
	'String','1', ...
	'Style', 'edit', ...
	'Tag','analysed_point_x');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.75 0.704 0.15 0.04], ...
	'String','Y', ...
	'Style','text', ...
	'Tag','StaticText_point');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.80 0.714 0.11 0.04], ...
	'String','1', ...
	'Style', 'edit', ...
	'Tag','analysed_point_y');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.48, ...
	'Position',[0.02 0.565 0.96 0.050], ...
	'Style','frame', ...
	'Tag','Frame_Results');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.568 0.8 0.035], ...
	'String','Results', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graphs of the 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.181818181818182, ...
	'Position',[0.02 0.425 0.96 0.132], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.507 0.8 0.035], ...
	'String','2-microlocal Frontier', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');


%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.445 0.6 0.04], ...
	'String','Plotting the 2-microlocal frontier', ...
	'Style','text', ...
	'Tag','StaticText_example');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2frontier_compute(''choice_example'');', ...
	'FontSize',0.88*0.48, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625  0.445  0.20    0.05], ...
	'String',{'No','Yes'}, ...
	'Style','popupmenu', ...
	'Tag','choice_examp', ...
	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exponents FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.0923076923076923, ...
	'Position',[0.02 0.155 0.96 0.260], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.360 0.8 0.035], ...
	'String','Estimation of', ...
	'Style','text', ...
	'Tag','StaticText_regularity');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.320 0.8 0.035], ...
	'String','two regularity exponents', ...
	'Style','text', ...
	'Tag','StaticText_regularity');

%%
%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'FontSize',0.88*0.6, ...
%	'HorizontalAlignment','left', ...
%	'Position',[0.05 0.310 0.65 0.04], ...
%	'String','Compute the exponents?', ...
%	'Style','text', ...
%	'Tag','StaticText_comp');

%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'Callback','fl_d2ml2frontier_compute(''compute_exponents'');', ...
%	'FontSize',0.88*0.48, ...
%	'ListboxTop',0, ...
%	'Max',2, ...
%	'Min',1, ...
%	'Position',[0.625 0.310 0.20  0.05], ...
%	'String',{'No','Yes'}, ...
%	'Style','popupmenu', ...
%	'Tag','compute_exp', ...
%	'Value',1);

%%
%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'FontSize',0.88*0.685714285714286, ...
%	'Enable','off',...
%	'HorizontalAlignment','left', ...
%	'Position',[0.05 0.270 0.65 0.035], ...
%	'String','Pointwise exponent(1st method)', ...
%	'Style','text', ...
%	'Tag','StaticText_pointwise1');
%
%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'Enable','off',...
%	'BackgroundColor',[1 1 1], ...
%	'FontSize',0.88*0.685714285714286, ...
%	'HorizontalAlignment','center', ...
%	'Position',[0.65 0.272 0.15 0.035], ...
%	'String','', ...
%	'Style','text', ...
%	'Tag','EditText_pointwise1');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'Enable','on',...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.241 0.65 0.035], ...
	'String','Pointwise Holder exponent', ...
	'Style','text', ...
	'Tag','StaticText_pointwise2');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Enable','on',...
	'FontSize',0.88*0.685714285714286, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.240 0.15 0.035], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive', ...
	'Tag','EditText_pointwise2');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.685714285714286, ...
	'Enable','on',...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.182 0.65 0.035], ...
	'String','Local Holder exponent', ...
	'Style','text', ...
	'Tag','StaticText_local');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Enable','on',...
	'FontSize',0.88*0.685714285714286, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.181 0.15 0.035], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive', ...
	'Tag','EditText_local');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Waitbar FRAME
%
%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'FontSize',0.88*0.3, ...
%	'Position',[0.02 0.065 0.96 0.080], ...
%	'Style','frame', ...
%	'Tag','Frame_Waitbar');

%%
%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'FontSize',0.88*0.6, ...
%	'FontWeight','bold', ...	
%	'HorizontalAlignment','left', ...
%	'Position',[0.05 0.080 0.65 0.04], ...
%	'String','Waitbar on screen?', ...
%	'Style','text', ...
%	'Tag','StaticText_wait');

%b = uicontrol('Parent',a, ...
%	'Units','normalized', ...
%	'FontUnits','normalized', ...
%	'Callback','fl_d2ml2frontier_compute(''waitbar_screen'');', ...
%	'FontSize',0.88*0.48, ...
%	'ListboxTop',0, ...
%	'Max',2, ...
%	'Min',1, ...
%	'Position',[0.625 0.080 0.20  0.05], ...
%	'String',{'Yes','No'}, ...
%	'Style','popupmenu', ...
%	'Tag','wait_screen', ...
%	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GENERAL BUTTONS



b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','eval([''global '' fl_d2ml2frontier_compute(''compute'',who)]);', ...	
	'FontSize',0.88*0.48, ...
	'Enable','off',...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.03 0.01 0.24 0.05], ...
	'String','Compute', ...
	'Tag','compute');

   
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','helpwin aide_ml2frontier;', ...
	'FontSize',0.88*0.48, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.38 0.01 0.24 0.05], ...
	'String','Help', ...
	'Tag','button_help');   

 
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2frontier_compute(''close'');', ...
	'FontSize',0.88*0.48, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.73 0.01 0.24 0.05], ...
	'String','Close', ...
	'Tag','button_close');
	
fl_window_init(a); 	

    
fl_d2ml2frontier_compute('refresh_input');    
    
if nargout > 0, fig = a; end
