function fig = gui_fl_estimcrossingtree()

h0 = figure( ...
	'Colormap',[], ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Name','Estimation of the Hurst index via the crossing tree', ...
	'Position',[20 50 400 600], ...
	'Tag','Fig_gui_fl_estimcrossingtree');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.313599999999999, ...
	'ListboxTop',0, ...
	'Position',[0.0275 0.94 0.9400000000000001 0.05], ...
	'Style','frame', ...
	'Tag','Frameestimcrossingtree');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.05 0.945 0.9 0.035], ...
	'String','Estimation of the Hurst index via the crossing tree', ...
	'Style','text',  ...
	'Tag','StaticTextTitle');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.0846560846560844, ...
	'ListboxTop',0, ...
	'Position',[0.0275 0.15 0.9400000000000001 0.2], ...
	'Style','frame', ...
	'Tag','FrameParam');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.0846560846560844, ...
	'ListboxTop',0, ...
	'Position',[0.0275 0.42 0.9400000000000001 0.15], ...
	'Style','frame', ...
	'Tag','FrameParam1');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.0846560846560844, ...
	'ListboxTop',0, ...
	'Position',[0.0275 0.58 0.9400000000000001 0.35], ...
	'Style','frame', ...
	'Tag','FrameParam2');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.05 0.88 0.9 0.035], ...
	'String','Crossings', ...
	'Style','text',  ...
	'Tag','Frame1Title');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.05 0.52 0.9 0.035], ...
	'String','Hurst Index', ...
	'Style','text',  ...
	'Tag','Frame2Title');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.05 0.3 0.9 0.035], ...
	'String','Confidence interval', ...
	'Style','text',  ...
	'Tag','Frame3Title');	

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.835 0.2525 0.06333333333333334/2], ...
	'String','Input Signal', ...
	'Style','text', ...
	'Tag','StaticText_input');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.3425 0.84 0.34 0.03], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive',...
	'Tag','EditText_input');

    h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''launch'');', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.7075 0.84 0.225 0.03], ...
	'String','Refresh', ...
	'Tag','Pushbutton_refreshInput');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'Callback','fl_estimcrossingtree_compute(''isTimeSeries'');', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.78 0.2525 0.06333333333333334/2], ...
	'String','Time Vector', ...
	'Style','checkbox', ...
	'Tag','checkbox_inputtime');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.3425 0.78 0.34 0.03], ...
	'String','Time indexed', ...
	'Style','edit', ...
	'Enable','off',...
	'Tag','EditText_inputtime');

    h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''launch_time'');', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.7075 0.78 0.225 0.03], ...
	'String','Refresh', ...
	'Enable','off',...
	'Tag','Pushbutton_refreshInputtime');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.72 0.1525 0.06333333333333334/2], ...
	'String','Levels', ...
	'Style','text', ...
	'Tag','StaticText_levels');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.2425 0.72 0.24 0.03], ...
	'String','[3:5]', ...
	'Style','edit', ...
	'Tag','EditText_levels');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.53 0.72 0.1525 0.06333333333333334/2], ...
	'String','Delta', ...
	'Style','text', ...
	'Tag','StaticText_delta');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.6925 0.72 0.24 0.03], ...
	'String','0', ...
	'Style','edit', ...
	'Tag','EditText_delta');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.66 0.5325 0.06333333333333334/2], ...
	'String','Delete first crossing at each level', ...
	'Style','checkbox', ...
	'Value',1,...
	'Tag','checkbox_deletefirst');
	
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.63 0.66 0.25 0.06333333333333334/2], ...
	'String','Plot crossings', ...
	'Style','checkbox', ...
	'Value',1,...
	'Tag','checkbox_plot_Xing');


    h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''get_hits'');', ...
	'FontSize',0.88*1.1*0.599999999999999, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.25 0.6 0.25 0.03], ...
	'String','Get hits', ...
	'Tag','Pushbutton_get_hits');

    h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''clear_hits'');', ...
	'FontSize',0.88*1.1*0.599999999999999, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.55 0.6 0.25 0.03], ...
	'String','Clear hits', ...
	'enable','off',...
	'Tag','Pushbutton_clear_hits');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.48 0.1525 0.06333333333333334/2], ...
	'String','Level', ...
	'Style','text', ...
	'Tag','StaticText_levelH');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.2425 0.485 0.24 0.03], ...
	'String','5', ...
	'Style','edit', ...
	'Tag','EditText_levelH');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''computeH'');', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.3725 0.43 0.235 0.035], ...
	'String','Compute', ...
	'enable','off',...
	'Tag','Pushbutton_estimcrossingtreeH_compute');

h6 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.7, ...
	'FontWeight','bold',...
	'ListboxTop',0,...
	'Position',[0.2 0.37 0.2 0.03],...
	'String','Hurt Index',...
	'Style','text',...
	'Tag','StaticText6');

h1 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.6, ...
	'ListboxTop',0,...
	'Position',[0.57 0.37 0.18 0.03],...
	'Style','edit',...
	'Tag','EditText_HurstIndexH');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.255 0.1525 0.06333333333333334/2], ...
	'String','Level', ...
	'Style','text', ...
	'Tag','StaticText_level');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.2425 0.26 0.24 0.03], ...
	'String','5', ...
	'Style','edit', ...
	'Tag','EditText_level');


h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.53 0.255 0.1525 0.06333333333333334/2], ...
	'String','Method', ...
	'Style','text', ...
	'Tag','StaticText_method');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.88*1.1*0.533333333333332, ...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[0.6925 0.26 0.24 0.03], ...
	'Callback','fl_estimcrossingtree_compute(''edittext_method'');', ...
	'String',{'iid','srd','lrd'}, ...
	'Style','popupmenu', ...
	'Tag','EditText_method');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.08 0.21 0.3325 0.06333333333333334/2], ...
	'String','Bias Corrected', ...
	'Style','checkbox', ...
	'Value',1,...
	'Tag','checkbox_biasCorrected');
	
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.55, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[0.53 0.21 0.3125 0.06333333333333334/2], ...
	'String','Diagnostic Plot', ...
	'Style','checkbox', ...
	'Enable','off', ...
	'Tag','checkbox_diagnosticPlot');


	
	
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','eval([''global '' fl_estimcrossingtree_compute(''compute'',who)]);', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.3725 0.16 0.235 0.035], ...
	'String','Compute', ...
	'enable','off',...
	'Tag','Pushbutton_estimcrossingtree_compute');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_estimcrossingtree_compute(''help'')', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1775 0.02 0.235 0.035], ...
	'String','Help', ...
	'Tag','Pushbutton1');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'ButtonDownFcn','fl_estimcrossingtree_compute(''help'')', ...
	'Callback','close(gcf);fl_clearerror', ...
	'FontSize',0.88*1.1*0.5, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.5825 0.02 0.235 0.035], ...
	'String','Close', ...
	'Tag','Pushbutton_cancel');		
		
h7 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.3, ...
	'FontWeight','bold',...
	'ListboxTop',0,...
	'Position',[0 0.07 0.35 0.06],...
	'String','Hurt Index (with lower and upper bound)',...
	'Style','text',...
	'Tag','StaticText7');

h1 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.6, ...
	'ListboxTop',0,...
	'Position',[0.35 0.09 0.18 0.03],...
	'Style','edit',...
	'Tag','EditText_HurstIndex_lb');

h8 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.7, ...
	'FontWeight','bold',...
	'ListboxTop',0,...
	'Position',[0.54 0.09 0.02 0.025],...
	'String','<',...
	'Style','text',...
	'Tag','StaticText8');

h1 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'BackgroundColor',[1 1 1],...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.6, ...
	'ListboxTop',0,...
	'Position',[0.57 0.09 0.18 0.03],...
	'Style','edit',...
	'Tag','EditText_HurstIndex');

h9 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.7, ...
	'FontWeight','bold',...
	'ListboxTop',0,...
	'Position',[0.76 0.09 0.02 0.025],...
	'String','<',...
	'Style','text',...
	'Tag','StaticText9');


h1 = uicontrol(...
	'Parent',h0,...
	'Units','normalized',...
	'FontUnits','normalized', ...
	'FontSize',0.88*1.1*0.6, ...
	'ListboxTop',0,...
	'Position',[0.79 0.09 0.18 0.03],...
	'Style','edit',...
	'Tag','EditText_HurstIndex_ub');




fl_window_init(h0);
set(h6,'BackgroundColor',fl_getOption('BackGroundColor'));
set(h7,'BackgroundColor',fl_getOption('BackGroundColor'));
set(h8,'BackgroundColor',fl_getOption('BackGroundColor'));
set(h9,'BackgroundColor',fl_getOption('BackGroundColor'));

set(h6,'ForegroundColor',fl_getOption('AltFontColor'));
set(h7,'ForegroundColor',fl_getOption('AltFontColor'));
set(h8,'ForegroundColor',fl_getOption('AltFontColor'));
set(h9,'ForegroundColor',fl_getOption('AltFontColor'));

	
if nargout > 0, fig = h0; end
