function fig = gui_superpose()

% MAIN WINDOW
h0 = figure( ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Position',[130 300 250 150], ...
	'Tag','gui_superpose');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.444444444444444, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.8 0.96 0.18], ...
	'Style','frame', ...
	'Tag','Frame1');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.142762 0.85 0.7 0.08], ...
	'String','Superpose Parameters', ...
	'Style','text', ...
	'Tag','StaticText1');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*0.135593220338983, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.2 0.96 0.59], ...
	'Style','frame', ...
	'Tag','Frame2');
 
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1, ...
	'ListboxTop',0, ...
	'Position',[0.05    0.5    0.25    0.08], ...
	'String','lut ratio', ...
	'Style','text', ...
	'Tag','StaticText_lutRatio');

h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_superpose(''edit_lutRatio'');', ...
	'FontSize',0.88*0.666666666666667, ...
	'ListboxTop',0, ...
	'Position',[0.33    0.48    0.2    0.12], ...
	'String','0.8', ...
	'Style','edit', ...
	'Tag','EditText_lutRatio');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_superpose(''slider_lutRatio'');', ...
	'FontSize',0.88*0.666666666666667, ...
	'Max',1, ...
	'Min',0.5, ...
	'Position',[0.55 0.48 0.4 0.12], ...
	'Style','slider', ...
	'Tag','Slider_lutRatio', ...
	'Value',0.8);
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.88*1, ...
	'ListboxTop',0, ...
	'Position',[0.05    0.33    0.25    0.08], ...
	'String','threshold', ...
	'Style','text', ...
	'Tag','StaticText_threshold');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_superpose(''edit_threshold'');', ...
	'FontSize',0.88*0.666666666666667, ...
	'ListboxTop',0, ...
	'Position',[0.33    0.33    0.2    0.12], ...
	'String','0.01', ...
	'Style','edit', ...
	'Tag','EditText_threshold');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_superpose(''slider_threshold'');', ...
	'FontSize',0.88*0.666666666666667, ...
	'Max',0.2, ...
	'Min',0, ...
	'Position',[0.55 0.33 0.4 0.12], ...
	'Style','slider', ...
	'Tag','Slider_threshold', ...
	'Value',0.01);
   
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_superpose(''compute_superpose'');', ...
	'FontSize',0.88*0.533333333333333, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.02 0.3 0.15], ...
	'String','Apply', ...
	'Tag','button_Ok');    
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_superpose(''Close'');', ...
	'FontSize',0.88*0.533333333333333, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.6 0.02 0.3 0.15], ...
	'String','Close', ...
	'Tag','button_Close');    
	
fl_window_init(h0);	
    
if nargout > 0, fig = h0; end
