function [H, H_osc, a, regab, logosc] = exposc3(x,base,rmin,rmax,RegParam,timeinstant)
%exemples de parametres : x=signal d'entree,base=2.1
%rmin=1 a 3, rmax=7 a 10.
%a=exposant estime

if nargin<5
    RegParam={'ls'};
end
if nargin<6
    timeinstant = 0;
end

n = length(x);
if timeinstant ~= 0
	 for rho = rmin:rmax
			ray(rho-rmin+1) = (base^rho)/n;
			larg(rho-rmin+1) = 1+2*round(base^rho);
			i = timeinstant;
			osc(rho-rmin+1) = max(x(max(1,i-round(base^rho)):min(n,i+round(base^rho))))-min(x(max(1,i-round(base^rho)):min(n,i+round(base^rho))));
	end
	
	H=fl_regression(log(larg),log(osc),'a_hat','PointwiseHolderExponentOscillations',2,RegParam{:});

else
	osc = zeros(n,rmax-rmin+1);
	
	h_waitbar = fl_waitbar('init');
	
	for rho = rmin:rmax
			fl_waitbar('view',h_waitbar,rho/3,rmax-rmin+1);
			ray(rho-rmin+1) = (base^rho)/n;
			larg(rho-rmin+1) = 1+2*round(base^rho);
			for i = 1:n
					osc(i,rho-rmin+1) = max(x(max(1,i-round(base^rho)):min(n,i+round(base^rho))))-min(x(max(1,i-round(base^rho)):min(n,i+round(base^rho))));
			end
	end
	
	%regab=linspace(rmin,rmax,rmax-rmin+1),
	%larg
	regab = log(larg);
	logosc = log(osc);
	logray = log(ray);
	for i=1:length(logray)
			H_osc(:,i) = logosc(:,i)/logray(i);
	end
	H_osc_mean = mean(H_osc,2);


	a = zeros(1,n);
	for i = 1:n
	   fl_waitbar('view',h_waitbar,1/3*n+i/3, n);
	   %a1 = polyfit(regab,logosc(i,:),1);%newnewreg(regab,logosc(i,:),'linf',0,0,0);
	   %a(1,i) = a1(1);
	   a(1,i) = fl_monolr(regab,logosc(i,:),RegParam{:});
	end
	
	%large = (((n/3)/2)^(1/rmax))/base;
	large= 1;
	elarg = 1+2*round((large*base)^rmax);
	%H = zeros(1,n);
	
	%for i=1:n
	%	v_large(1) = max(1,i-round((large*base)^rmax));
	%	v_large(2) = min(n,i+round((large*base)^rmax));
	%	
	%	moy_a = nanmean(a(v_large(1):v_large(2)));
	%	moy_H_osc_mean = nanmean(H_osc_mean(v_large(1):v_large(2)));
	%
	%	H(i)=H_osc_mean(i)-moy_H_osc_mean+moy_a;
	%end
	
	v_large(1,1) = 1;
	v_large(2,1) = min(n,1+round((large*base)^rmax));
	
	sum_a(1) = nansum(a(v_large(1,1):v_large(2,1)));
	moy_a(1) = sum_a(1)/(v_large(2,1)-v_large(1,1)+1-sum(isnan(a(v_large(2,1):v_large(1,1)+1))));
	sum_H_osc_mean(1) = nansum(H_osc_mean(v_large(1,1):v_large(2,1)));
	moy_H_osc_mean(1) = sum_H_osc_mean(1)/(v_large(2,1)-v_large(1,1)+1-sum(isnan(H_osc_mean(v_large(2,1):v_large(1,1)+1))));
	
	for i=2:n
		fl_waitbar('view',h_waitbar,2/3*(n-1)+i/3, n-1);
		
		v_large(1,2) = max(1,i-round((large*base)^rmax));
		v_large(2,2) = min(n,i+round((large*base)^rmax));
	
		sum_a(i) = sum_a(i-1)+nansum(a(v_large(2,1)+1:v_large(2,2)))-nansum(a(v_large(1,1):v_large(1,2)-1));
		moy_a(i) = sum_a(i)/(v_large(2,1)-v_large(1,1)+1-sum(isnan(a(v_large(2,1):v_large(1,1)+1))));
		sum_H_osc_mean(i) = sum_H_osc_mean(i-1)+nansum(H_osc_mean(v_large(2,1)+1:v_large(2,2)))-nansum(H_osc_mean(v_large(1,1):v_large(1,2)-1));
		moy_H_osc_mean(i) = sum_H_osc_mean(i)/(v_large(2,1)-v_large(1,1)+1-sum(isnan(H_osc_mean(v_large(2,1):v_large(1,1)+1))));
		
		v_large(1,1) = v_large(1,2);
		v_large(2,1) = v_large(2,2);
		
	end		
	
	H=H_osc_mean'-moy_H_osc_mean+moy_a;

	fl_waitbar('close',h_waitbar);
end