function [X, Hxy] = krigging2D(n,fxy)

x = linspace(0,1,n(1));
y = linspace(0,1,n(2));
[X,Y]=meshgrid(x,y);
f = inline(fxy,'x','y');
Hxy = f(X,Y);

%Step 1 and 2 : Generate u fBm 2D
U = 9;

g = (fix(log(2*n-1)/log(2)+1));
m=2.^g;
W_xy = fft2(randn(m));
W_x = fft(randn(m(1),1))/sqrt(m(1));
W_y = fft(randn(1,m(2))).'/sqrt(m(2));

Bh = zeros(n(1),n(2),U);

for u=1:U
	Hu(u) = u/(U+1);
	Bh(:,:,u) = fastfBm2D(n,Hu(u),W_xy,W_x,W_y);
end

for i=2:n(1)-1
	for j=2:n(2)-1
		% Zij = [B_Hv(k1,k2), (v,k1,k2) in Nij] taille 1*18
		I = [i-1 i-1 i-1 i i i i+1 i+1 i+1];
		I = [I I];
		J = [j-1 j j+1];
		J = [J J J J J J];
		u=1;
		while Hxy(i,j) >= Hu(u)
			u = u+1;
		end
		u = max(1,u);
		u = min(u,U);
		H_index = [(u-1)*ones(1,9) (u)*ones(1,9)];
		H = [Hu(u-1)*ones(1,9) Hu(u)*ones(1,9)];
		for k=1:18
			x1 = I(k);
			x2 = J(k);
			Hx = H(k);
			
			Z(k,1) = Bh(x1,x2,H_index(k));
			
			Hij = Hxy(i,j);
			Hxy2 = (Hx+Hij)/2;
			B(k,1) = gg(Hx,Hij)/2*((x1^2+x2^2)^Hxy2+(i^2+j^2)^Hxy2+((x1-i)^2+(x2-j)^2)^Hxy2);
			
			for l=1:18
				y1 = I(l);
				y2 = J(l);
				Hy = H(l);
				Hxy2 = (Hx+Hy)/2;
				A(k,l) = gg(Hx,Hy)/2*((x1^2+x2^2)^Hxy2+(y1^2+y2^2)^Hxy2+((x1-y1)^2+(x2-y2)^2)^Hxy2);
			end
			
		end
		g_opt = inv(A)*B;
		X(i,j) = g_opt'*Z;
	end
end

X = X(2:n(1)-1,2:n(2)-1);


function [gg] = gg(h1,h2)
gg = ii((h1+h2)/2)/sqrt(ii(h1)*ii(h2));

%%%%%%%%%%%%%%%%%%
function [ii]=ii(h);
if h<0.5
	q=1/h;
	ii=gamma(1-2*h)*q*sin(pi*(0.5-h));
elseif h==0.5;
	ii=pi;
else
	qq=1/(h*(2*h-1));
	ii=gamma(2-2*h)*qq*sin(pi*(h-0.5));
end;